config/routes.rb
Rails.application.routes.draw do
  root to: 'dashboard#show'
  get 'locked' => 'pages#locked', as: :locked_screen
  get 'thankyou' => 'pages#thankyou', as: :thankyou_screen

  devise_for :staffs
  devise_for :users

  resources :tickets do
    member do
      put :feedback_submit
    end
    collection do
      get :search
    end
    resources :comments
  end

  resources :todos
  resources :products do
    collection do
        get :search
      end
  end
  resources :quotes
  resource :account, controller: :account
  resource :staff_account, controller: :staff_account
  resources :notifications do
    collection do
      put :mark_as_read
    end
  end

  namespace :manager do
    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :users
  end
 

  namespace :admin do
    resources :staffs
    
  end

  namespace :guest do
    resources :tickets
  end
  
  namespace :staff do
    resources :quotes do
      member do
        post :create_ticket
      end
    end



    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :tickets do
      member do
        put :feedback_submit
      end
      collection do
        get :search
      end
    end
    resources :clients do
      resources :users do
      collection do
        get :search
      end
    end
 
    end
  end

end

app/models/staff.rb
class Staff < ApplicationRecord
  ROLES = {'engineer' => 'Engineer', 'admin' => 'Admin'}
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :tickets
  has_many :todos, as: :creator
  has_many :comments, as: :creator
  has_many :notifications, as: :notifiable
  has_attached_file :photo, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/noimg.png"
  validates_attachment_content_type :photo, content_type: /\Aimage\/.*\z/

  ROLES.each do |k, v|
    define_method "is_#{k}?" do
      role == k
    end
  end
end

app/models/user.rb
class User < ApplicationRecord
  ROLES = { 'manager' => 'Manager', 'end_user' => 'User'}

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :tickets
  has_many :quotes
  belongs_to :client
  has_many :todos, as: :creator
  has_many :comments, as: :creator
  has_many :notifications, as: :notifiable

  has_attached_file :photo, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/noimg.png"
  validates_attachment_content_type :photo, content_type: /\Aimage\/.*\z/
  
  validates :role, inclusion: ROLES.keys


  ROLES.each do |k, v|
    define_method "is_#{k}?" do
      role == k
    end
  end
end

app/controllers/admin/staffs_controller.rb
class Admin::StaffsController < Admin::BaseController

  def new
    @staff = Staff.new 
  end

  def edit
    @staff= Staff.find(params[:id])
  end

  def update
    @staff= Staff.find(params[:id])
    if @staff.update_attributes(staff_params)
      flash[:success]="Successfully updated"
      redirect_to admin_staffs_path(@staff)
    else
      render 'edit'
    end
  end

  def index
     @staffs = Staff.where(is_deleted: false).order(name: :asc)
  end

  def destroy
    @staff= Staff.find(params[:id])
    @staff.update_attributes is_deleted: true
    redirect_to admin_staffs_path
  end

  def create
    @staff = Staff.new(staff_params)
    if @staff.save
      redirect_to admin_staffs_path
    else
      render action: 'new'
    end
  end

  private
    def staff_params
      params.require(:staff).permit(:name, :email, :password, :password_confirmation, :role, :is_deleted).tap do |p|
        if p[:password].empty? and p[:password_confirmation].empty?
          p.delete :password
          p.delete :password_confirmation
        end
      end
    end
end

app/controllers/manager/users_controller.rb
class Manager::UsersController < ApplicationController

  def new
    @user = User.new
  end

  def index
    @user = User.new
    @users = User.where(client_id: current_user.client_id, is_deleted: false).order(name: :asc)
  end

  def create
    @user = User.new(user_params)
    @user.client_id = current_user.client_id
    if @user.save
      redirect_to manager_users_path
    else
      render action: 'new'
    end
  end

  def edit
    @user = User.find(params[:id])
  end

  def update
    @user= User.find(params[:id])
    if @user.update_attributes(user_params)
      flash[:success]="Successfully updated"
      redirect_to manager_users_path()
    else
      render 'edit'
    end
  end

  def destroy
    @user= User.find(params[:id])
    @user.update_attributes is_deleted: true
    redirect_to manager_users_path
  end

  private
    def user_params
      params.require(:user).permit(:name, :email, :password, :password_confirmation, :role)
    end
    
end

app/controllers/staff/base_controller.rb
class Staff::BaseController < ApplicationController
  before_action :authenticate_staff!
end

app/controllers/staff/clients_controller.rb
class Staff::ClientsController < ApplicationController

  def new
    @client = Client.new 
  end

  def index
    @clients = Client.where(is_deleted: false).order(name: :asc)
  end

  def edit
    @client= Client.find(params[:id])
  end
  
  def create
    @client = Client.new(client_params)
    if @client.save
      redirect_to staff_clients_path
    else
      render action: 'new'
    end
  end

  def update
    @client= Client.find(params[:id])
    if @client.update_attributes(client_params)
      flash[:success]="Successfully updated"
      redirect_to staff_client_path(@client)
    else
      render 'edit'
    end
  end

  def show
    @client= Client.find(params[:id])
     @users = @client.users.where(is_deleted: false).order(name: :asc)
    @user = User.new
  end

  def destroy
    @client= Client.find(params[:id])
    @client.is_deleted = true
    @client.save
    redirect_to staff_clients_path
  end

  private
    def client_params
      params.require(:client).permit(:name, :address, :logo, :phone, :email, :website, :is_deleted)
    end
    
end

app/controllers/staff/dashboard_controller.rb
class Staff::DashboardController < Staff::BaseController

  def show
    @tickets =Ticket
    @todos = current_staff.todos.where(is_completed: false).order(created_at: :asc)
  end
  
  def chart_data
    data = prepare_data(tickets_scope)
    colors = data_colors[0..data.count-1]

    op = {
      labels: data.keys,
      datasets: [{
        label: "Ticket Stats",
        data: data.values,
        backgroundColor: colors,
        hoverBackgroundColor: colors
      }]
    }

    render json: JSON.dump(op)
  end

  private
  def tickets_scope
    tickets = Ticket
    tickets = case params[:filter]
    when 'open'
      tickets.open
    when 'overdue'
      tickets.where("status=? and expected_closing_date < ?", "in_progress", Date.today)
    when 'in_progress'
      tickets.where(status: "in_progress")
    when 'due_today'
      tickets.where("status != ? and expected_closing_date = ?", "closed", Date.today)
    when 'unassigned'
      tickets.where(staff: nil)
    when 'closed'
      tickets.where(status: "closed")
    else
      tickets
    end

    tickets
  end

  def prepare_data(scope)
    op = {}
    Ticket::CATEGORIES.each do |c|
      count = scope.where(category: c).count
      op[c] = count if count > 0
    end
    if (count = scope.where('category IS NULL OR category NOT IN (?)', Ticket::CATEGORIES).count) > 0
      op['Others'] = count
    end

    op
  end

  def data_colors
    [
      "#222222",
      "#b8b8b8",
      "#00dac7",
      "#5C5C5C",
      "#ff5252",
      "#2196F3",
      "#4CAF50",
      "#FF0084",
      "#f57c00"
    ].shuffle
  end
end

app/controllers/staff/quotes_controller.rb
class Staff::QuotesController < ApplicationController

  def create_ticket
    quote = Quote.find params[:id]
    if !quote.ticket_id.present?
      Ticket.with_performer current_staff do
        ticket = Ticket.new
        ticket.name = quote.name
        ticket.subject = "Quote from #{quote.name}"
        ticket.user_id = quote.user_id
        ticket.priority = 'medium'
        ticket.description = quote.description
        ticket.source = quote.preferred_method
        ticket.save!
        quote.ticket_id = ticket.id
        quote.save
      end
      redirect_to staff_tickets_path
    end
  end

  def index
    @quotes = Quote.all.order(id: :desc)
  end

  def show
    @quote = Quote.find params[:id]
  end
  
end

app/controllers/staff/tickets_controller.rb
class Staff::TicketsController < Staff::BaseController

  def new
    @ticket = current_staff.tickets.new(priority: 'low', name: current_staff.name)
  end

  def create
    Ticket.with_performer current_staff do
      @ticket = current_staff.tickets.new(t_params)
      if @ticket.save
        redirect_to staff_tickets_path
      else
        render action: 'new'
      end
    end
  end


  def index
    @tickets =Ticket.all.order(id: :desc)
    if params[:status].present?
      if params[:status] == "unassigned"
        @tickets = Ticket.where(staff_id: nil)
      elsif params[:status] == "overdue"
        @tickets = @tickets.where("status != ? and expected_closing_date < ?", "closed", Date.today)
      elsif params[:status] == "due_today"
        @tickets = @tickets.where("status != ? and expected_closing_date = ?", "closed", Date.today)
      elsif
        @tickets = @tickets.where(status: params[:status])
      end
    else
      @tickets = @tickets.where(status: nil)
    end
    respond_to do |format|
      format.html
      format.csv do
        headers['Content-Disposition'] = "attachment; filename=\"tickets-list.csv\""
        headers['Content-Type'] ||= 'text/csv'
      end
      format.pdf do
        render pdf: "tickets-list", disposition: 'attachment', layout: 'pdf'
      end
    end
  end

  def show
    @ticket = Ticket.find params[:id]
    @quote = Quote.find_by_ticket_id(@ticket.id) 
    @staffs = Staff.all
  end

  def update
    @ticket = Ticket.find params[:id]
    Ticket.with_performer current_staff do
      @ticket.update_attributes! ticket_params
    end
    
    redirect_to staff_ticket_path(@ticket)
  end

  def feedback_submit
    @ticket = Ticket.find params[:id]
    Ticket.with_performer current_user do
      @ticket.update_attributes(feedback_params)
      params[:success] = 'Feedback received'
      redirect_to ticket_path(@ticket)
    end
  end

  def search
    @tickets = Ticket.where("1=1")
    @tickets = @tickets.where(status: params[:search][:status]) if params[:search][:status].present?
    @tickets = @tickets.where(staff_id: params[:search][:staff_id]) if params[:search][:staff_id].present?
    @tickets = @tickets.where(priority: params[:search][:priority]) if params[:search][:priority].present?
    @tickets = @tickets.where(category: params[:search][:category]) if params[:search][:category].present?
    @tickets = @tickets.joins(:user).where("users.client_id": params[:search][:client_id]) if params[:search][:client_id].present?

    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @tickets = @tickets.where("name LIKE ? OR subject LIKE ?", query, query)
    end

    render action: :index
  end

  private
    def ticket_params
      op = params.require(:ticket).permit(:status, :priority, :staff_id)
      op[:status] = nil if op[:status] == ""
      op
    end

    def t_params
      params.require(:ticket).permit(:name, :subject, :description, :priority, :attachment,:category, :source, :service_type, :user_id, :expected_closing_date)
    end

    def feedback_params
      params.require(:ticket).permit(:feedback_score, :feedback_comment)
    end
end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new 
    @client= Client.find(params[:client_id])
  end

  def show
    @client= Client.find(params[:client_id])
    @user = User.find(params[:id])
  end

  def edit
    @user = User.find(params[:id])
    @client= Client.find(params[:client_id])
  end

  def update
    @client= Client.find(params[:client_id])
    @user= User.find(params[:id])
      if @user.update_attributes(user_params)
        flash[:success]="Successfully updated"
        redirect_to staff_client_user_path()
      else
        render 'edit'
    end
  end

  def create
    @client= Client.find(params[:client_id])
    @user = User.new(user_params)
    @user.client_id = @client.id
    if @user.save
      redirect_to staff_client_path(@client)
    else
      render action: 'new'
    end
  end

  def search
  @client= Client.find(params[:client_id])
  @users = User.where(client_id: @client.id)
  if params[:search][:query].present?
    query = '%' + params[:search][:query] + '%'
    @users = @users.where("name LIKE ? OR email LIKE ?", query, query)
  end
  render template: 'staff/clients/show'
  end

  def destroy
    @client= Client.find(params[:client_id])
    @user = User.find(params[:id])
    @user.is_deleted = true
    @user.save
    redirect_to staff_client_path(@client)
  end

  private
    def user_params
      op = params.require(:user).permit(:photo, :name, :email, :password, :password_confirmation, :role, :is_deleted)
      if op[:password].blank? and op[:password_confirmation].blank?
        op.delete :password
        op.delete :password_confirmation
      end
      return op
    end
    
end

app/helpers/admin/staff_helper.rb
module Admin::StaffHelper
end

app/helpers/admin/users_helper.rb
module Admin::UsersHelper
end

app/helpers/manager/users_helper.rb
module Manager::UsersHelper
end

app/helpers/staff/clients_helper.rb
module Staff::ClientsHelper
end

app/helpers/staff/quotes_helper.rb
module Staff::QuotesHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/views/staff/users/_new.html.erb
<div class="card-header">
  <h5 class="card-header-text">New User</h5>
</div>

<div class="p-l-20 p-r-20 p-b-20">
  <%= form_for @user, url: staff_client_users_path(@client) , html: {class: "wizard clearfix"} do |f| %>
  
    <%= f.error_messages %>
    <div class="md-group-add-on">
      <span class="md-add-on">
        <i class="icofont icofont-ui-user"></i>
      </span>
      <div class="md-input-wrapper">
        <%=f.text_field :name, class: 'md-form-control' %>
        <%=f.label :name %>
      </div>
    </div>

    <div class="md-group-add-on">
      <span class="md-add-on">
        <i class="icofont icofont-ui-email"></i>
      </span>
      <div class="md-input-wrapper">
        <%=f.email_field :email, class: 'md-form-control' %>
        <%=f.label :email %>
      </div>
    </div>

    <div class="md-group-add-on">
      <span class="md-add-on">
        <i class="icofont icofont-ui-password"></i>
      </span>
      <div class="md-input-wrapper">
        <%=f.password_field :password, class: 'md-form-control' %>
        <%=f.label :password %>
      </div>
    </div>

    <div class="md-group-add-on">
      <span class="md-add-on">
        <i class="icofont icofont-key"></i>
      </span>
      <div class="md-input-wrapper">
        <%=f.password_field :password_confirmation, class: 'md-form-control' %>
        <%=f.label :"Re enter Password" %>
      </div>
    </div>
    
    <div class="md-group-add-on">
      <span class="md-add-on">
        <i class="icofont icofont-funky-man"></i>
      </span>
      <div class="md-input-wrapper">
        <%=f.select :role, options_for_select(User::ROLES.collect{|k, v| [v, k]}, selected: f.object.role), {}, class: 'md-form-control md-static' %>
        <%=f.label :role %>
      </div>
    </div>

    <div class="text-center">
      <%= f.submit "create", class: "btn btn-primary" %>
      <%= link_to 'Cancel', staff_client_path(@client), class: "btn btn-primary" %>
    </div>

  <% end %>
</div>

app/views/staff/users/edit.html.erb
<div class="container-fluid">
  <div class="p-t-30">
    <div class="row">
      <div class="col-sm-12">
        <div class="card">
          <div class="card-header">
            <h5 class="card-header-text"></h5>
          </div>
          <div class="p-l-20 p-r-20 p-b-20">
            <%= form_for @user, url: staff_client_user_path(@client, @user) , html: {class: "wizard clearfix", method: 'PUT'} do |f| %>
            
              <%= f.error_messages %>
              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-ui-user"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.text_field :name, class: 'md-form-control' %>
                  <%=f.label :name %>
                </div>
              </div>

              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-ui-email"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.email_field :email, class: 'md-form-control' %>
                  <%=f.label :email %>
                </div>
              </div>

              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-key"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.password_field :password, class: 'md-form-control' %>
                  <%=f.label :password %>
                </div>
              </div>

              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-key"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.password_field :password_confirmation, class: 'md-form-control' %>
                  <%=f.label :"Re enter password" %>
                </div>
              </div>
              
              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-funky-man"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.select :role, options_for_select(User::ROLES.collect{|k, v| [v, k]}, selected: f.object.role), {}, class: 'md-form-control md-static' %>
                  <%=f.label :role %>
                </div>
              </div>

              <div class="text-center">
                <%= f.submit "Update", class: "btn btn-primary" %>
                <%= link_to 'Cancel', staff_client_path(@client), class: "btn btn-primary" %>
              </div>

            <% end %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
  
            

            

app/views/staff/users/new.html.erb
<div class="container-fluid">
  <div class="p-t-30">
    <div class="row">
      <div class="col-sm-12">
        <div class="card">
            <%= render 'staff/users/new' %>
        </div>
      </div>
    </div>
  </div>
</div>
   

            

app/views/staff/users/show.html.erb
<div class="container-fluid">
  <div class="row">
    <div class="main-header" style="margin-top: 0px;">
      <h4>Users Details</h4>
    </div>
  </div>
  <div class="card">
    <div class="card-block ">
      <div class="contact-mobi-front">
        <i class="icofont icofont-navigation-menu contact-btn " style="display: none;"></i>
        <div class="contact-details-front-img">
          <%= image_tag @user.photo.url, class: 'd-inline-block img-circle' %>
        </div>
        <div class="container">
          <div class="md-float-material">
            <div class="row">
              <div class="col-xl-8 offset-xl-2">
                <table class="table m-0">
                  <tbody>
                    <tr>
                      <th scope="row">Name</th>
                      <td><%= @user.name %></td>
                    </tr>
                    <tr>
                      <th scope="row">Email</th>
                      <td><%= @user.email %></td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
            <div class="contact-card-button">
              <%= link_to 'Edit', edit_staff_client_user_path, class: "btn btn-primary" %>
              <%= link_to 'Cancel', staff_client_path(@client), class: "btn btn-primary" %>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>